apt 2.9.16 commandline package manager

Classes | Public Types | Public Member Functions | List of all members
Solver Class Reference

## Classes
struct | CompareProviders3
struct | Solved
| A solved item. More...
struct | State
| The solver state. More...
struct | Var
| Tagged union holding either a package, version, or nothing; representing the reason for installing something. More...
struct | Work
| A single work item. More...

## Public Types
enum class | Decision : uint16_t { NONE , MUST , MUSTNOT }
enum class | Hint : uint16_t { NONE , SHOULD , MAY }

## Public Member Functions
void | Push (Work work)
bool | Pop ()
void | UndoOne ()
void | AddWork (Work &&work)
void | RescoreWorkIfNeeded ()
| Solver (pkgCache &Cache, pkgDepCache::Policy &Policy)
bool | Assume (Var var, bool decision, Var reason)
bool | Enqueue (Var var, bool decision, Var reason)
bool | Install (pkgCache::PkgIterator Pkg, Var reason, Group group)
bool | FromDepCache (pkgDepCache &depcache)
bool | ToDepCache (pkgDepCache &depcache)
bool | Solve ()
std::string | WhyStr (Var reason)

## Constructor & Destructor Documentation

## ◆ Solver()

Solver | ( | pkgCache & | cache,
|  | pkgDepCache::Policy & | policy )

Todo
  DEDUP with pkgDepCache.

## Member Function Documentation

## ◆ Pop()

bool Pop | ( |  | ) |

Todo
  We should just mark the entries as erased and only do a compaction

Todo
  There should be a reason!

## ◆ UndoOne()

void UndoOne | ( |  | ) |

Todo
  Add the undo handling here once we have watchers.

References pkgCache::Version::ParentPkg, and pkgCache::Version::VerStr.

The documentation for this class was generated from the following files:

- apt-pkg/solver3.h
- apt-pkg/solver3.cc